sleep 1;

setViewDistance 3000;
setObjectViewDistance [3000,0];

TEST_MinPlayerDistance = getMissionConfigValue ["minPlayerDistance",0];

if (hasInterface) then
{
	player allowDamage false;
	
	onMapSingleClick
	"
		player setPos _pos;
	
		openMap [false, false];
	";
	
	_radioTrigger = createTrigger["EmptyDetector",[-1000,-1000,0]];
	_radioTrigger setTriggerActivation ["ALPHA","PRESENT",true];
	_radioTrigger setTriggerStatements ["this",'(allUnits - [player]) apply {if (alive _x) then {_x setDamage 1;};};',""];
	(1) setRadioMsg "Kill All Men";
	
	_radioTrigger = createTrigger["EmptyDetector",[-1000,-1000,0]];
	_radioTrigger setTriggerActivation ["BRAVO","PRESENT",true];
	_radioTrigger setTriggerStatements ["this",'vehicles apply {if (alive _x) then {_x setDamage 1;};};',""];
	(2) setRadioMsg "Destroy All Vehicles";
	
	_radioTrigger = createTrigger["EmptyDetector",[-1000,-1000,0]];
	_radioTrigger setTriggerActivation ["CHARLIE","PRESENT",true];
	_radioTrigger setTriggerStatements ["this",'TEST_SpawnActive = !TEST_SpawnActive; publicVariable "TEST_SpawnActive"; systemChat format ["TEST_SpawnActive: %1",TEST_SpawnActive];',""];
	(3) setRadioMsg "Toggle Spawning";
	
	_radioTrigger = createTrigger["EmptyDetector",[-1000,-1000,0]];
	_radioTrigger setTriggerActivation ["DELTA","PRESENT",true];
	_radioTrigger setTriggerStatements ["this",'TEST_SpawnPositionAt000 = !TEST_SpawnPositionAt000; publicVariable "TEST_SpawnPositionAt000"; systemChat format ["TEST_SpawnPositionAt000: %1",TEST_SpawnPositionAt000];',""];
	(4) setRadioMsg "Toggle SpawnPosition (player/000)";
	
	_radioTrigger = createTrigger["EmptyDetector",[-1000,-1000,0]];
	_radioTrigger setTriggerActivation ["ECHO","PRESENT",true];
	_radioTrigger setTriggerStatements ["this",'TEST_AutoRevealActive = !TEST_AutoRevealActive; publicVariable "TEST_AutoRevealActive"; systemChat format ["TEST_AutoRevealActive: %1",TEST_AutoRevealActive];',""];
	(5) setRadioMsg "Toggle Auto Reveal";
	
	_radioTrigger = createTrigger["EmptyDetector",[-1000,-1000,0]];
	_radioTrigger setTriggerActivation ["FOXTROT","PRESENT",true];
	_radioTrigger setTriggerStatements ["this",'TEST_UnitsInPlayerGroup = !TEST_UnitsInPlayerGroup; publicVariable "TEST_UnitsInPlayerGroup"; systemChat format ["TEST_UnitsInPlayerGroup: %1",TEST_UnitsInPlayerGroup];',""];
	(6) setRadioMsg "Toggle Units in Player Group";
	
	_radioTrigger = createTrigger["EmptyDetector",[-1000,-1000,0]];
	_radioTrigger setTriggerActivation ["GOLF","PRESENT",true];
	_radioTrigger setTriggerStatements ["this",'TEST_RemoveFromRemainsCollector = !TEST_RemoveFromRemainsCollector; publicVariable "TEST_RemoveFromRemainsCollector"; systemChat format ["TEST_RemoveFromRemainsCollector: %1",TEST_RemoveFromRemainsCollector];',""];
	(7) setRadioMsg "Toggle RemoveFromRemainsCollector";
	
	_radioTrigger = createTrigger["EmptyDetector",[-1000,-1000,0]];
	_radioTrigger setTriggerActivation ["HOTEL","PRESENT",true];
	_radioTrigger setTriggerStatements ["this",'TEST_AddToRemainsCollector = !TEST_AddToRemainsCollector; publicVariable "TEST_AddToRemainsCollector"; systemChat format ["TEST_AddToRemainsCollector: %1",TEST_AddToRemainsCollector];',""];
	(8) setRadioMsg "Toggle AddToRemainsCollector";
	
	_radioTrigger = createTrigger["EmptyDetector",[-1000,-1000,0]];
	_radioTrigger setTriggerActivation ["INDIA","PRESENT",true];
	_radioTrigger setTriggerStatements ["this",'addToRemainsCollector (allUnits + vehicles + allDeadMen);',""];
	(9) setRadioMsg "Add all to AddToRemainsCollector";
	
	_radioTrigger = createTrigger["EmptyDetector",[-1000,-1000,0]];
	_radioTrigger setTriggerActivation ["JULIET","PRESENT",true];
	_radioTrigger setTriggerStatements ["this",'removeFromRemainsCollector (allUnits + vehicles + allDeadMen)',""];
	(10) setRadioMsg "Add all to RemoveFromRemainsCollector";
};

TEST_SpawnActive = true;
TEST_SpawnPositionAt000 = false;
TEST_AutoRevealActive = false;
TEST_UnitsInPlayerGroup = false;

TEST_RemoveFromRemainsCollector = false;
TEST_AddToRemainsCollector = false;

TEST_KilledInfantry = 0;
TEST_DestroyedVehicles = 0;

TEST_RemovedInfantry = 0;
TEST_RemovedVehicles = 0;
TEST_RemovedGroups = 0;

[] spawn
{
	if (!(hasInterface)) exitWith {};

	while {true} do
	{
		_allAliveUnits = allUnits select {alive _x};
		_allDestroyedVehicles = allDead select {(!(_x isKindOf "Man")) && {(!(alive _x))}};
		_allAliveVehicles = vehicles select {(!(_x isKindOf "Man")) && {(alive _x)}};
	
		hintSilent format
		[
			"All Units: %1 (%2) [%3 < %24m] \n" +
			"All DeadMen: %4 (%5) [%6 < %24m] \n" +
//			"All Alive Men: %7 (%8) [%9 < %24m] \n" +
			"All Vehicles: %10 (%11) [%12 < %24m] \n" +
			"All Dead Vehicles: %13 (%14) [%15 < %24m] \n" +
			"All Alive Vehicles: %16 (%17) [%18 < %24m] \n" +

			"Killed Infantry: %19 \n" +
			"Destroyed Vehicles: %20 \n" +
			"Removed Infantry: %21 \n" +
			"Removed Vehicles: %22 \n" +
			"Removed Groups: %23 \n",

			count (allUnits),{isInRemainsCollector _x} count allUnits,{(player distance _x) < TEST_MinPlayerDistance} count allUnits,
			count (allDeadMen),{isInRemainsCollector _x} count allDeadMen,{(player distance _x) < TEST_MinPlayerDistance} count allDeadMen,
			count (_allAliveUnits),{isInRemainsCollector _x} count (_allAliveUnits),{(player distance _x) < TEST_MinPlayerDistance} count _allAliveUnits,
			count (vehicles),{isInRemainsCollector _x} count vehicles,{(player distance _x) < TEST_MinPlayerDistance} count vehicles,
			count (_allDestroyedVehicles),{isInRemainsCollector _x} count (_allDestroyedVehicles),{(player distance _x) < TEST_MinPlayerDistance} count _allDestroyedVehicles,
			count (_allAliveVehicles),{isInRemainsCollector _x} count (_allAliveVehicles),{(player distance _x) < TEST_MinPlayerDistance} count _allAliveVehicles,

			TEST_KilledInfantry,
			TEST_DestroyedVehicles,
			TEST_RemovedInfantry,
			TEST_RemovedVehicles,
			TEST_RemovedGroups,

			TEST_MinPlayerDistance
		];

		sleep 1;
	};
};

addMissionEventHandler ["EntityKilled",
{
	params ["_unit","_killer","_instigator","_useEffects"];
	
	if (TEST_RemoveFromRemainsCollector) then
	{
		removeFromRemainsCollector [_unit];
	};

	if (TEST_AutoRevealActive) then
	{
		[TEST_Player,[_unit,4]] remoteExec ["reveal",0];
	};

	_text = format ["MEH: %1 has been killed (%2m)",_unit,_unit distance TEST_Player];

	[_text] remoteExec ["systemChat",0];
}];

addMissionEventHandler ["GroupDeleted",
{
	params ["_group"];

	TEST_RemovedGroups = TEST_RemovedGroups + 1;

	publicVariable "TEST_RemovedGroups";

	_text = format ["MEH: %1 has been deleted",_group];

	[_text] remoteExec ["systemChat",0];
}];

[] spawn
{
	if (!(isServer)) exitWith {};

	TEST_DummyGroup = createGroup civilian;
	TEST_PlayerGroup = group TEST_Player;

	while {true} do
	{
		if (TEST_SpawnActive) then
		{
			_basePosition = [0,0,0];

			if (!(TEST_SpawnPositionAt000)) then
			{
				_basePosition = position TEST_Player ;
			};

			_group = TEST_DummyGroup;

			if (TEST_UnitsInPlayerGroup) then
			{
				_group = TEST_PlayerGroup;
			};

			//Infantry
			_positionInfantry = _basePosition getPos [random 500,random 360];

			_unit = _group createUnit ["B_RangeMaster_F",_positionInfantry,[],0,"CAN_COLLIDE"];

			if (TEST_AddToRemainsCollector) then
			{
				addToRemainsCollector [_unit];
			}
			else
			{
				if (TEST_RemoveFromRemainsCollector) then
				{
					removeFromRemainsCollector [_unit];
				};
			};

			_index = _unit addEventHandler ["Killed",
			{
				params ["_unit","_killer","_instigator","_useEffects"];
	
				if (TEST_RemoveFromRemainsCollector) then
				{
					removeFromRemainsCollector [_unit];
				};

				if (TEST_AutoRevealActive) then
				{
					[TEST_Player,[_unit,4]] remoteExec ["reveal",0];
				};

				TEST_KilledInfantry = TEST_KilledInfantry + 1;

				publicVariable "TEST_KilledInfantry";

				_unit setVariable ["Test_TimeOfDeath",time,true];

				_text = format ["AEH: %1 has been killed (%2m)",_unit,_unit distance TEST_Player];

				[_text] remoteExec ["systemChat",0];
			}];

			_index = _unit addEventHandler ["Deleted",
			{
				params ["_entity"];

				TEST_RemovedInfantry = TEST_RemovedInfantry + 1;

				publicVariable "TEST_RemovedInfantry";

				_timeOfDeath = _entity getVariable ["Test_TimeOfDeath",time];

				_text = format ["AEH: %1 has been deleted (%2m) [%3s]",_entity,_entity distance TEST_Player ,time - _timeOfDeath];

				[_text] remoteExec ["systemChat",0];
			}];

			// Vehicles
			_positionInfantryVehicle = _basePosition getPos [random 500,random 360];

			_vehicle = createVehicle ["B_MRAP_01_F",_positionInfantryVehicle,[],0,"CAN_COLLIDE"];

			if (TEST_AddToRemainsCollector) then
			{
				addToRemainsCollector [_vehicle];
			}
			else
			{
				if (TEST_RemoveFromRemainsCollector) then
				{
					removeFromRemainsCollector [_vehicle];
				};
			};

			_index = _vehicle addEventHandler ["Killed",
			{
				params ["_unit","_killer","_instigator","_useEffects"];
	
				if (TEST_RemoveFromRemainsCollector) then
				{
					removeFromRemainsCollector [_unit];
				};

				if (TEST_AutoRevealActive) then
				{
					[TEST_Player,[_unit,4]] remoteExec ["reveal",0];
				};

				TEST_DestroyedVehicles = TEST_DestroyedVehicles + 1;

				publicVariable "TEST_DestroyedVehicles";

				_unit setVariable ["Test_TimeOfDeath",time,true];

				_text = format ["AEH: %1 has been destroyed (%2m)",_unit,_unit distance TEST_Player];

				[_text] remoteExec ["systemChat",0];
			}];

			_index = _vehicle addEventHandler ["Deleted",
			{
				params ["_entity"];

				TEST_RemovedVehicles = TEST_RemovedVehicles + 1;

				publicVariable "TEST_RemovedVehicles";

				_timeOfDeath = _entity getVariable ["Test_TimeOfDeath",time];


				_text = format ["AEH: %1 has been deleted (%2m) [%3s]",_entity,_entity distance TEST_Player ,time - _timeOfDeath];

				[_text] remoteExec ["systemChat",0];
			}];
		};

		sleep 1;
	};
};
